<template>
    <base-detail-page :title="$t('profile.setting')">
        <div v-if="load">{{ $t('event.load') }}</div>
        <form
            v-else
            class="settings-form base-detail-page__default-margin"
            data-vv-scope="settings-form-scope"
            @submit.prevent='saveSettings'
            autocomplete="off"
        >
            <base-container size="mini">
                <div class="settings-form__separator">
                    <h2>{{ $t('profile.password.title') }}</h2>
                    <!-- Старый пароль start -->
                    <div class="input-kit default-margin-input input-kit--relative">
                        <input
                            :type="visiblePassword.oldPassword ? 'text' : 'password'"
                            :placeholder="$t('profile.password.old_password')"
                            name="oldPassword"
                            class="input main"
                            v-model="oldPassword"
                        >
                        <div
                            :class="[
                                'input-kit__eye',
                                 getClassForEyes('oldPassword'), 'pointer'
                             ]"
                            @click="changeVisiblePassword('oldPassword')"
                        ></div>
                    </div>
                    <!-- Старый пароль end -->
                    <!-- Новый пароль start -->
                    <div class="input-kit default-margin-input input-kit--relative">
                        <input
                            ref="password"
                            :type="visiblePassword.newPassword ? 'text' : 'password'"
                            :placeholder="$t('profile.password.new_password')"
                            name="newPassword"
                            class="input main"
                            v-model.lazy="newPassword"
                            v-validate="'password'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                            @keydown.native="test"
                        >
                        <div
                            :class="[
                                'input-kit__eye',
                                 getClassForEyes('newPassword'), 'pointer'
                             ]"
                            @click="changeVisiblePassword('newPassword')"
                        />
                        <transition name="slide">
                            <div
                                v-show="errors.has('settings-form-scope.newPassword') &&
                                newPassword !== '' &&
                                focusElement !== 'newPassword'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('newPassword', 'settings-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>
                    <!-- Новый пароль end -->
                    <!-- Новый пароль еще раз start -->
                    <div class="input-kit default-margin-input input-kit--relative">
                        <input
                            :type="visiblePassword.reNewPassword ? 'text' : 'password'"
                            :placeholder="$t('profile.password.new_password_again')"
                            name="reNewPassword"
                            class="input main"
                            v-model.lazy="reNewPassword"
                            v-validate="'repassword:password'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <div
                            :class="[
                                'input-kit__eye',
                                 getClassForEyes('reNewPassword'), 'pointer'
                             ]"
                            @click="changeVisiblePassword('reNewPassword')"
                        />
                        <transition name="slide">
                            <div
                                v-show="errors.has('settings-form-scope.reNewPassword') &&
                                reNewPassword !== '' &&
                                focusElement !== 'reNewPassword'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('reNewPassword', 'settings-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>
                    <!-- Новый пароль еще раз end -->
                </div>

                <div class="settings-form__separator">
                    <h2>{{ $t('profile.contact_data.title') }}</h2>
                    <!-- Email адрес start -->
                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            :placeholder="$t('profile.contact_data.email')"
                            name="email"
                            class="input main"
                            v-model.lazy="accountEmail"
                            v-validate="'email'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('settings-form-scope.email') &&
                                email !== '' &&
                                focusElement !== 'email'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('email', 'settings-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>
                    <!-- Email адрес end -->
                    <!-- Дополнительный Email адрес start -->
                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            :placeholder="$t('profile.contact_data.extra_email')"
                            name="additionalEmail"
                            class="input main"
                            v-model.lazy="additionalEmail"
                            v-validate="'email'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('settings-form-scope.additionalEmail') &&
                                additionalEmail !== '' &&
                                focusElement !== 'additionalEmail'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('additionalEmail', 'settings-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>
                    <!-- Дополнительный Email адрес end -->
                </div>
                <div class="settings-form__separator">
                    <h2>{{ $t('profile.confidentiality.title') }}</h2>
                    <!-- Профиль start -->
                    <base-checkbox
                        name="profile"
                        :profile.sync="profile"
                        :required="false"
                    >
                        {{ $t('profile.confidentiality.first_profile') }}
                    </base-checkbox>
                    <!-- Профиль end -->
                    <!-- ОИС start -->
                    <base-checkbox
                        name="ois"
                        :ois.sync="ois"
                        :required="false"
                    >
                        {{ $t('profile.confidentiality.list') }}
                    </base-checkbox>
                    <!-- ОИС end -->
                </div>
                <div class="settings-form__separator">
                    <h2>{{ $t('profile.view.title') }}</h2>
                    <!-- Информация о правах start -->
                    <base-checkbox
                        name="rightsInformation"
                        :rightsInformation.sync="rightsInformation"
                        :required="false"
                    >
                        {{ $t('profile.view.info') }}
                    </base-checkbox>
                    <!-- Информация о правах end -->
                    <!-- История транзакций start -->
                    <base-checkbox
                        name="transactionHistory"
                        :transactionHistory.sync="transactionHistory"
                        :required="false"
                    >
                        {{ $t('profile.view.transactions') }}
                    </base-checkbox>
                    <!-- История транзакций end -->
                    <!-- Показывать остальные предложения start -->
                    <base-checkbox
                        name="otherSentences"
                        :otherSentences.sync="otherSentences"
                        :required="false"
                    >
                        {{ $t('profile.view.rest_proposals') }}
                    </base-checkbox>
                    <!-- Показывать остальные предложения end -->
                    <!-- Исключить из поисковой выдачи start -->
                    <base-checkbox
                        name="exclude"
                        :exclude.sync="exclude"
                        :required="false"
                    >
                        {{ $t('profile.view.exception') }}
                    </base-checkbox>
                    <!-- Исключить из поисковой выдачи end -->
                </div>
            </base-container>
            <base-container size="small">
                <div class="grouped-buttons settings-form__grouped-buttons">
                    <base-button
                        :text="$t('button.save')"
                        size="210px"
                        position="right"
                        theme="save"
                    />
                </div>
            </base-container>
        </form>
    </base-detail-page>
</template>

<script>
import inputs from 'mixins/inputs';

export default {
    name: 'settings',
    mixins: [ inputs ],
    data() {
        return {
            oldPassword: '',
            newPassword: '',
            reNewPassword: '',
            additionalEmail: '',
            email: '',
            profile: false,
            ois: false,
            rightsInformation: false,
            transactionHistory: false,
            otherSentences: false,
            exclude: false,
            load: false,
            visiblePassword: {
                oldPassword: false,
                newPassword: false,
                reNewPassword: false
            }
        };
    },
    components: {

    },
    computed: {
        accountEmail: {
            get() {
                if (this.user.email === this.email && this.user.email !== undefined) {
                    this.email = this.user.email;
                }
                return this.email || this.user.email;
            },
            set(newValue) {
                this.email = newValue;
            }
        },
        ...mapState('account', ['user'])
    },
    created() {

    },
    methods: {
        test() {
            console.warn(123);
        },
        changeVisiblePassword(name) {
            if (this.visiblePassword[name] !== undefined) this.visiblePassword[name] = !this.visiblePassword[name];
        },
        getClassForEyes(name) {
            return this.visiblePassword[name] ? 'input-kit__eye--open' : 'input-kit__eye--close';
        },
        saveSettings() {
            console.warn('saveSettings');
        }
    }
};
</script>

<style lang="sass">
    .settings-form
        &__separator
            margin-bottom: 68px
</style>
